<?php

/**
 * Base class that represents a row from the 'katao_member_adhesion' table.
 *
 * 
 *
 * @package    lib.model.om
 */
abstract class BaseKataoMemberAdhesion extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        KataoMemberAdhesionPeer
	 */
	protected static $peer;


	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;


	/**
	 * The value for the katao_user_id field.
	 * @var        int
	 */
	protected $katao_user_id;


	/**
	 * The value for the year field.
	 * @var        int
	 */
	protected $year;


	/**
	 * The value for the amount field.
	 * @var        double
	 */
	protected $amount;


	/**
	 * The value for the type field.
	 * @var        int
	 */
	protected $type;


	/**
	 * The value for the payment_kind field.
	 * @var        int
	 */
	protected $payment_kind;


	/**
	 * The value for the check_no field.
	 * @var        string
	 */
	protected $check_no;

	/**
	 * @var        KataoUser
	 */
	protected $aKataoUser;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{

		return $this->id;
	}

	/**
	 * Get the [katao_user_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoUserId()
	{

		return $this->katao_user_id;
	}

	/**
	 * Get the [optionally formatted] [year] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getYear($format = 'Y-m-d')
	{

		if ($this->year === null || $this->year === '') {
			return null;
		} elseif (!is_int($this->year)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->year);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [year] as date/time value: " . var_export($this->year, true));
			}
		} else {
			$ts = $this->year;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [amount] column value.
	 * 
	 * @return     double
	 */
	public function getAmount()
	{

		return $this->amount;
	}

	/**
	 * Get the [type] column value.
	 * 
	 * @return     int
	 */
	public function getType()
	{

		return $this->type;
	}

	/**
	 * Get the [payment_kind] column value.
	 * 
	 * @return     int
	 */
	public function getPaymentKind()
	{

		return $this->payment_kind;
	}

	/**
	 * Get the [check_no] column value.
	 * 
	 * @return     string
	 */
	public function getCheckNo()
	{

		return $this->check_no;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = KataoMemberAdhesionPeer::ID;
		}

	} // setId()

	/**
	 * Set the value of [katao_user_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoUserId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_user_id !== $v) {
			$this->katao_user_id = $v;
			$this->modifiedColumns[] = KataoMemberAdhesionPeer::KATAO_USER_ID;
		}

		if ($this->aKataoUser !== null && $this->aKataoUser->getId() !== $v) {
			$this->aKataoUser = null;
		}

	} // setKataoUserId()

	/**
	 * Set the value of [year] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setYear($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [year] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->year !== $ts) {
			$this->year = $ts;
			$this->modifiedColumns[] = KataoMemberAdhesionPeer::YEAR;
		}

	} // setYear()

	/**
	 * Set the value of [amount] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setAmount($v)
	{

		if ($this->amount !== $v) {
			$this->amount = $v;
			$this->modifiedColumns[] = KataoMemberAdhesionPeer::AMOUNT;
		}

	} // setAmount()

	/**
	 * Set the value of [type] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setType($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->type !== $v) {
			$this->type = $v;
			$this->modifiedColumns[] = KataoMemberAdhesionPeer::TYPE;
		}

	} // setType()

	/**
	 * Set the value of [payment_kind] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setPaymentKind($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->payment_kind !== $v) {
			$this->payment_kind = $v;
			$this->modifiedColumns[] = KataoMemberAdhesionPeer::PAYMENT_KIND;
		}

	} // setPaymentKind()

	/**
	 * Set the value of [check_no] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setCheckNo($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->check_no !== $v) {
			$this->check_no = $v;
			$this->modifiedColumns[] = KataoMemberAdhesionPeer::CHECK_NO;
		}

	} // setCheckNo()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param      int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->katao_user_id = $rs->getInt($startcol + 1);

			$this->year = $rs->getDate($startcol + 2, null);

			$this->amount = $rs->getFloat($startcol + 3);

			$this->type = $rs->getInt($startcol + 4);

			$this->payment_kind = $rs->getInt($startcol + 5);

			$this->check_no = $rs->getString($startcol + 6);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 7; // 7 = KataoMemberAdhesionPeer::NUM_COLUMNS - KataoMemberAdhesionPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating KataoMemberAdhesion object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      Connection $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoMemberAdhesion:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KataoMemberAdhesionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			KataoMemberAdhesionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseKataoMemberAdhesion:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param      Connection $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoMemberAdhesion:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KataoMemberAdhesionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseKataoMemberAdhesion:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      Connection $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aKataoUser !== null) {
				if ($this->aKataoUser->isModified()) {
					$affectedRows += $this->aKataoUser->save($con);
				}
				$this->setKataoUser($this->aKataoUser);
			}


			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = KataoMemberAdhesionPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += KataoMemberAdhesionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aKataoUser !== null) {
				if (!$this->aKataoUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoUser->getValidationFailures());
				}
			}


			if (($retval = KataoMemberAdhesionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KataoMemberAdhesionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getKataoUserId();
				break;
			case 2:
				return $this->getYear();
				break;
			case 3:
				return $this->getAmount();
				break;
			case 4:
				return $this->getType();
				break;
			case 5:
				return $this->getPaymentKind();
				break;
			case 6:
				return $this->getCheckNo();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KataoMemberAdhesionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getKataoUserId(),
			$keys[2] => $this->getYear(),
			$keys[3] => $this->getAmount(),
			$keys[4] => $this->getType(),
			$keys[5] => $this->getPaymentKind(),
			$keys[6] => $this->getCheckNo(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KataoMemberAdhesionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setKataoUserId($value);
				break;
			case 2:
				$this->setYear($value);
				break;
			case 3:
				$this->setAmount($value);
				break;
			case 4:
				$this->setType($value);
				break;
			case 5:
				$this->setPaymentKind($value);
				break;
			case 6:
				$this->setCheckNo($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KataoMemberAdhesionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setKataoUserId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setYear($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setAmount($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setType($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setPaymentKind($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setCheckNo($arr[$keys[6]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(KataoMemberAdhesionPeer::DATABASE_NAME);

		if ($this->isColumnModified(KataoMemberAdhesionPeer::ID)) $criteria->add(KataoMemberAdhesionPeer::ID, $this->id);
		if ($this->isColumnModified(KataoMemberAdhesionPeer::KATAO_USER_ID)) $criteria->add(KataoMemberAdhesionPeer::KATAO_USER_ID, $this->katao_user_id);
		if ($this->isColumnModified(KataoMemberAdhesionPeer::YEAR)) $criteria->add(KataoMemberAdhesionPeer::YEAR, $this->year);
		if ($this->isColumnModified(KataoMemberAdhesionPeer::AMOUNT)) $criteria->add(KataoMemberAdhesionPeer::AMOUNT, $this->amount);
		if ($this->isColumnModified(KataoMemberAdhesionPeer::TYPE)) $criteria->add(KataoMemberAdhesionPeer::TYPE, $this->type);
		if ($this->isColumnModified(KataoMemberAdhesionPeer::PAYMENT_KIND)) $criteria->add(KataoMemberAdhesionPeer::PAYMENT_KIND, $this->payment_kind);
		if ($this->isColumnModified(KataoMemberAdhesionPeer::CHECK_NO)) $criteria->add(KataoMemberAdhesionPeer::CHECK_NO, $this->check_no);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(KataoMemberAdhesionPeer::DATABASE_NAME);

		$criteria->add(KataoMemberAdhesionPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of KataoMemberAdhesion (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setKataoUserId($this->katao_user_id);

		$copyObj->setYear($this->year);

		$copyObj->setAmount($this->amount);

		$copyObj->setType($this->type);

		$copyObj->setPaymentKind($this->payment_kind);

		$copyObj->setCheckNo($this->check_no);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     KataoMemberAdhesion Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     KataoMemberAdhesionPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new KataoMemberAdhesionPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a KataoUser object.
	 *
	 * @param      KataoUser $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoUser($v)
	{


		if ($v === null) {
			$this->setKataoUserId(NULL);
		} else {
			$this->setKataoUserId($v->getId());
		}


		$this->aKataoUser = $v;
	}


	/**
	 * Get the associated KataoUser object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoUser The associated KataoUser object.
	 * @throws     PropelException
	 */
	public function getKataoUser($con = null)
	{
		if ($this->aKataoUser === null && ($this->katao_user_id !== null)) {
			// include the related Peer class
			$this->aKataoUser = KataoUserPeer::retrieveByPK($this->katao_user_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoUserPeer::retrieveByPK($this->katao_user_id, $con);
			   $obj->addKataoUsers($this);
			 */
		}
		return $this->aKataoUser;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseKataoMemberAdhesion:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseKataoMemberAdhesion::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseKataoMemberAdhesion
